<template>
  <button
    class="h-[100px] rounded-lg relative z-0 overflow-hidden bg-5 concrete-card"
    @click="$emit('click', game)"
  >
    <div class="z-10">
      <template v-if="cardStyle === 'large'">
        <div class="z-10 absolute top-2 left-2">
          <img
            :src="getCardInfo.logoImage"
            class="w-16 h-6 mb-0.5 object-scale-down"
          />
          <p
            v-if="isShowDisplayName"
            class="w-[90px] text-[10px] font-medium tc-5 opacity-50 text-left"
          >
            {{ getCardInfo.displayName }}
          </p>
        </div>
        <SharedGameTags
          class="absolute bottom-2 left-2 z-10"
          :is-hot="getCardInfo.isHot"
          :is-new="getCardInfo.isNew"
        />
        <div
          class="absolute top-0.5 -right-3 w-[110px] h-[110px] scale-[calc(184/110)] blur-[20px] mix-blend-color"
        >
          <img :src="getCardInfo.starImage" class="w-full h-full" />
        </div>
        <div class="absolute top-0.5 -right-3 w-[110px] h-[110px]">
          <img :src="getCardInfo.starImage" class="w-full h-full" />
        </div>
      </template>
      <template v-else-if="cardStyle === 'small'">
        <SharedGameTags
          class="absolute top-2 left-2 z-10"
          :is-hot="getCardInfo.isHot"
          :is-new="getCardInfo.isNew"
        />
        <div class="z-10 absolute bottom-1 w-full flex flex-col items-center">
          <div class="w-[60px] h-6 flex items-center justify-center">
            <img :src="getCardInfo.logoImage" class="h-full" />
          </div>
          <p
            v-if="isShowDisplayName"
            class="text-[10px] font-medium tc-5 opacity-50 text-center"
          >
            {{ getCardInfo.displayName }}
          </p>
        </div>
        <div class="w-full h-full flex items-center justify-center">
          <div class="h-[100px] w-[100px] relative">
            <div
              class="h-[100px] aspect-square absolute scale-[1.85] blur-[20px] mix-blend-color"
            >
              <div class="h-[110px] aspect-square absolute left-2 top-1">
                <img class="w-full h-full" :src="getCardInfo.starImage" />
              </div>
            </div>
            <div class="h-[100px] w-[100px] absolute">
              <div class="h-[110px] aspect-square absolute left-2 top-1">
                <img class="w-full h-full" :src="getCardInfo.starImage" />
              </div>
            </div>
          </div>
        </div>
        <IconConcreteCardFade
          class="absolute bottom-0 w-full left-0 h-14"
          style="
            color: var(--background5);
            border-bottom-left-radius: 8px;
            border-bottom-right-radius: 8px;
          "
        />
      </template>
    </div>
    <img
      :src="getBackgroundImage"
      class="absolute top-0 right-0 h-full opacity-50 z-[-1]"
      style="border-radius: 8px"
    />
  </button>
</template>

<script setup lang="ts">
import SportDisplayModel from "~~/components/sport/sportDisplayModel";
import IconConcreteCardFade from "~~/assets/svg/concrete-card-fade.svg?component";
import { GameProviders } from "~~/models/bsiGameList";

defineEmits<{
  (e: "click", game: SportDisplayModel | GameProviders): void;
}>();

const props = withDefaults(
  defineProps<{
    game: SportDisplayModel | GameProviders;
    // eslint-disable-next-line vue/require-default-prop
    countByProvider?: Record<string, number>;
    cardStyle?: "large" | "small";
  }>(),
  {
    cardStyle: "large",
  }
);

const isShowDisplayName = computed(() => {
  if (
    props.cardStyle === "small" ||
    !props.countByProvider ||
    props.game instanceof GameProviders
  )
    return false;
  return props.countByProvider[props.game.GameProviderName] > 1;
});

const route = useRoute();

const { getAssetImage } = commonHelper;

const getBackgroundImage = computed(() => {
  let path = String(route.path)
    ?.toLowerCase()
    .replace(/[-\s/]/g, "");
  if (route.name === "index") {
    path = menuTabHeaders.value[0]?.TabType?.toLowerCase()?.replace(
      /[-\s/]/g,
      ""
    );
  }
  return getAssetImage(`/assets/common/concrete/bg-${path}.png`);
});

const getCardInfo = computed<{
  displayName: string;
  logoImage: string;
  starImage: string;
  isHot?: boolean;
  isNew?: boolean;
}>(() => {
  if (props.game instanceof SportDisplayModel) {
    const {
      GameNameForDisplay,
      ProviderLogoPath,
      StarImagePath,
      IsHotGame,
      IsNewGame,
    } = props.game;
    return {
      displayName: GameNameForDisplay,
      logoImage: ProviderLogoPath,
      starImage: StarImagePath,
      isHot: IsHotGame,
      isNew: IsNewGame,
    };
  }
  const { ProviderName, providerLogo, starLogo } = props.game;
  return {
    displayName: ProviderName,
    logoImage: providerLogo,
    starImage: starLogo,
  };
});
</script>

<style lang="scss" scoped></style>
